﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using Telerik.Windows.Controls.Map;

namespace VisualizationLayerShapeSelection
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.radMap.Loaded += radMap_Loaded;
        }

        AsyncShapeFileReader reader;
        void radMap_Loaded(object sender, RoutedEventArgs e)
        {
            reader = new AsyncShapeFileReader();
            this.visualizationLayer.Reader = reader; 
            //reader.SourceCollection.Add(new AsyncReaderSource() { Source = new Uri("/VisualizationLayerShapeSelection;component/Resources/world.shp", UriKind.RelativeOrAbsolute) });
        }

        private void ShowSelectedItems(object sender, RoutedEventArgs e)
        {
            string condition = this.filter.Text.Trim();
            double minSqkm;
            if (double.TryParse(condition, out minSqkm))
            {
                IEnumerable<object> itemsToSelect = from MapShapeData item in this.visualizationLayer.Items
                                                    where ((double)item.ExtendedData.GetValue("SQKM")) > minSqkm * 1000d
                                                    select item;
                this.visualizationLayer.Select(itemsToSelect, true);
            }
        }

        private void LoadShape(object sender, RoutedEventArgs e)
        {
            //this.visualizationLayer.ReverseSelection(this.visualizationLayer.Items);
            reader.SourceCollection.Clear();
            reader.SourceCollection.Add(new AsyncReaderSource() { Source = new Uri("/VisualizationLayerShapeSelection;component/Resources/world.shp", UriKind.RelativeOrAbsolute) });
            this.visualizationLayer.RefreshVirtualSource();
            reader.ReadAsync();
        }
    }
}
